﻿Public Class Form1

    Dim columnX(16) As Integer
    Dim rowY(16) As Integer
    Dim panels() As Panel

    Private Sub RotationToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TranslationToolStripMenuItem.Click, RotationToolStripMenuItem.Click, ReflectionToolStripMenuItem.Click, EnlargementToolStripMenuItem.Click
        Dim mi As ToolStripMenuItem = DirectCast(sender, ToolStripMenuItem)
        Dim parent As ToolStripMenuItem = TypeToolStripMenuItem

        For Each ddi As ToolStripMenuItem In parent.DropDownItems
            ddi.Checked = False
        Next

        mi.Checked = True

        DirectCast(Me.Controls(mi.Text.Replace("&", "") & "1"), Panel).BringToFront()

        Me.Text = "Transformations - " & mi.Text.Replace("&", "")

    End Sub

    Private Sub ExitToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitToolStripMenuItem.Click
        Application.Exit()
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Dim parts() As String = Environment.GetCommandLineArgs.Skip(1).ToArray
        'If parts.Length = 0 OrElse String.Join(" ", parts) <> "Maths Revision V1.0" Then End

        For x As Integer = 0 To 3
            sharedVariables.allHighlights.Add(Nothing)
            sharedVariables.allVertices.Add(New List(Of Point))
        Next
        For x As Integer = 0 To 16
            columnX(x) = 25 + x * 25
            rowY(x) = 25 + x * 25
        Next x

        panels = New Panel() {Enlargement1, Reflection1, Rotation1, Translation1}

        AddHandler Enlargement1.MouseMove, AddressOf panels_MouseMove
        AddHandler Enlargement1.MouseClick, AddressOf panels_MouseClick
        AddHandler Reflection1.MouseMove, AddressOf panels_MouseMove
        AddHandler Reflection1.MouseClick, AddressOf panels_MouseClick
        AddHandler Rotation1.MouseMove, AddressOf panels_MouseMove
        AddHandler Rotation1.MouseClick, AddressOf panels_MouseClick
        AddHandler Translation1.MouseMove, AddressOf panels_MouseMove
        AddHandler Translation1.MouseClick, AddressOf panels_MouseClick

        AddHandler Enlargement1.nudXPosition.ValueChanged, AddressOf numericupdowns_ValueChanged
        AddHandler Enlargement1.nudYPosition.ValueChanged, AddressOf numericupdowns_ValueChanged
        AddHandler Enlargement1.nudScale.ValueChanged, AddressOf numericupdowns_ValueChanged
        AddHandler Enlargement1.nudXPosition.KeyPress, AddressOf numericupdowns_KeyPress
        AddHandler Enlargement1.nudYPosition.KeyPress, AddressOf numericupdowns_KeyPress
        AddHandler Enlargement1.nudScale.KeyPress, AddressOf numericupdowns_KeyPress

        AddHandler Reflection1.nudIntersection.ValueChanged, AddressOf numericupdowns_ValueChanged
        AddHandler Reflection1.nudIntersection.KeyPress, AddressOf numericupdowns_KeyPress

        AddHandler Rotation1.nudXCentre.ValueChanged, AddressOf numericupdowns_ValueChanged
        AddHandler Rotation1.nudYCentre.ValueChanged, AddressOf numericupdowns_ValueChanged
        AddHandler Rotation1.nudAngle.ValueChanged, AddressOf numericupdowns_ValueChanged
        AddHandler Rotation1.nudXCentre.KeyPress, AddressOf numericupdowns_KeyPress
        AddHandler Rotation1.nudYCentre.KeyPress, AddressOf numericupdowns_KeyPress
        AddHandler Rotation1.nudAngle.KeyPress, AddressOf numericupdowns_KeyPress

        AddHandler Translation1.nudXPosition.ValueChanged, AddressOf numericupdowns_ValueChanged
        AddHandler Translation1.nudYPosition.ValueChanged, AddressOf numericupdowns_ValueChanged
        AddHandler Translation1.nudXPosition.KeyPress, AddressOf numericupdowns_KeyPress
        AddHandler Translation1.nudYPosition.KeyPress, AddressOf numericupdowns_KeyPress

        RotationToolStripMenuItem.PerformClick()
    End Sub

    Private Sub numericupdowns_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Enlargement1.Refresh()
        Reflection1.Refresh()
        Rotation1.Refresh()
        Translation1.Refresh()
    End Sub

    Private Sub numericupdowns_KeyPress(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs)
        e.Handled = True
    End Sub
    

    Private Sub panels_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs)
        Dim index As Integer = Array.IndexOf(panels, sender)

        Dim r As Integer = -1
        Dim c As Integer = -1

        For x As Integer = 0 To 16
            If e.Y >= rowY(x) - 3 AndAlso e.Y <= rowY(x) + 3 Then
                r = rowY(x)
                Exit For
            End If
        Next x
        For x As Integer = 0 To 16
            If e.X >= columnX(x) - 3 AndAlso e.X <= columnX(x) + 3 Then
                c = columnX(x)
                Exit For
            End If
        Next x
        If c > -1 AndAlso r > -1 Then
            sharedVariables.allHighlights(index) = New Point(c, r)
        Else
            sharedVariables.allHighlights(index) = Nothing
        End If
        DirectCast(sender, Panel).Refresh()
    End Sub

    Private Sub panels_MouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs)
        Dim index As Integer = Array.IndexOf(panels, sender)
        If sharedVariables.allHighlights(index) <> Nothing Then
            If sharedVariables.allVertices(index).Contains(sharedVariables.allHighlights(index)) Then
                sharedVariables.allVertices(index).Remove(sharedVariables.allHighlights(index))
            Else
                sharedVariables.allVertices(index).Add(sharedVariables.allHighlights(index))
            End If
            DirectCast(sender, Panel).Refresh()
        End If
    End Sub

End Class
