﻿Public Class Enlargement
    Inherits Panel

    Friend WithEvents ContextMenuStrip1 As System.Windows.Forms.ContextMenuStrip
    Private components As System.ComponentModel.IContainer
    Friend WithEvents ClearToolStripMenuItem As System.Windows.Forms.ToolStripMenuItem
    Friend WithEvents Panel1 As System.Windows.Forms.Panel
    Friend WithEvents nudScale As System.Windows.Forms.NumericUpDown
    Friend WithEvents Label6 As System.Windows.Forms.Label
    Friend WithEvents Label7 As System.Windows.Forms.Label
    Friend WithEvents nudXPosition As System.Windows.Forms.NumericUpDown
    Friend WithEvents Label8 As System.Windows.Forms.Label
    Friend WithEvents Label9 As System.Windows.Forms.Label
    Friend WithEvents Label10 As System.Windows.Forms.Label
    Friend WithEvents nudYPosition As System.Windows.Forms.NumericUpDown
    Friend WithEvents lblPolarity As System.Windows.Forms.Label

    Public Sub New()

        InitializeComponent()

        Me.DoubleBuffered = True

        Me.ContextMenuStrip = ContextMenuStrip1
        ContextMenuStrip1.Enabled = False

        Me.Controls.Add(Panel1)
        Panel1.SetBounds(25, 458, Panel1.Width, Panel1.Height, BoundsSpecified.Location)

        Me.Dock = DockStyle.Fill

    End Sub

    Protected Overrides Sub OnPaint(ByVal e As System.Windows.Forms.PaintEventArgs)
        e.Graphics.SmoothingMode = Drawing2D.SmoothingMode.HighQuality

        methods.drawGrid(e.Graphics, Me.Font)

        Dim l As Integer = pointMethods.c2X(CInt(nudXPosition.Value))
        Dim t As Integer = pointMethods.r2Y(CInt(nudYPosition.Value))
        Dim s As Decimal = nudScale.Value

        methods.drawShape(e.Graphics, sharedVariables.allVertices(0))
        methods.drawEnlargedShape(e.Graphics, l, t, s, lblPolarity.Text, sharedVariables.allVertices(0))
        methods.drawBorders(e.Graphics, Me.BackColor)
        methods.drawCross(e.Graphics, l, t)
        methods.drawHighlight(e.Graphics, sharedVariables.allHighlights(0))

        MyBase.OnPaint(e)
    End Sub

    Private Sub ClearToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ClearToolStripMenuItem.Click
        sharedVariables.allVertices(0).Clear()
        Me.Refresh()
    End Sub

    Private Sub lblPolarity_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lblPolarity.Click
        If lblPolarity.Text = "+" Then lblPolarity.Text = "-" Else lblPolarity.Text = "+"
        Me.Refresh()
    End Sub

    Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Me.ContextMenuStrip1 = New System.Windows.Forms.ContextMenuStrip(Me.components)
        Me.ClearToolStripMenuItem = New System.Windows.Forms.ToolStripMenuItem
        Me.Panel1 = New System.Windows.Forms.Panel
        Me.nudScale = New System.Windows.Forms.NumericUpDown
        Me.Label6 = New System.Windows.Forms.Label
        Me.Label7 = New System.Windows.Forms.Label
        Me.nudXPosition = New System.Windows.Forms.NumericUpDown
        Me.Label8 = New System.Windows.Forms.Label
        Me.Label9 = New System.Windows.Forms.Label
        Me.Label10 = New System.Windows.Forms.Label
        Me.lblPolarity = New System.Windows.Forms.Label
        Me.nudYPosition = New System.Windows.Forms.NumericUpDown
        Me.ContextMenuStrip1.SuspendLayout()
        Me.Panel1.SuspendLayout()
        CType(Me.nudScale, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.nudXPosition, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.nudYPosition, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'ContextMenuStrip1
        '
        Me.ContextMenuStrip1.Items.AddRange(New System.Windows.Forms.ToolStripItem() {Me.ClearToolStripMenuItem})
        Me.ContextMenuStrip1.Name = "ContextMenuStrip1"
        Me.ContextMenuStrip1.Size = New System.Drawing.Size(102, 26)
        '
        'ClearToolStripMenuItem
        '
        Me.ClearToolStripMenuItem.Name = "ClearToolStripMenuItem"
        Me.ClearToolStripMenuItem.Size = New System.Drawing.Size(101, 22)
        Me.ClearToolStripMenuItem.Text = "Clear"
        '
        'Panel1
        '
        Me.Panel1.Controls.Add(Me.nudScale)
        Me.Panel1.Controls.Add(Me.Label6)
        Me.Panel1.Controls.Add(Me.Label7)
        Me.Panel1.Controls.Add(Me.nudXPosition)
        Me.Panel1.Controls.Add(Me.Label8)
        Me.Panel1.Controls.Add(Me.Label9)
        Me.Panel1.Controls.Add(Me.Label10)
        Me.Panel1.Controls.Add(Me.lblPolarity)
        Me.Panel1.Controls.Add(Me.nudYPosition)
        Me.Panel1.Location = New System.Drawing.Point(23, 243)
        Me.Panel1.Name = "Panel1"
        Me.Panel1.Size = New System.Drawing.Size(405, 20)
        Me.Panel1.TabIndex = 16
        '
        'nudScale
        '
        Me.nudScale.DecimalPlaces = 1
        Me.nudScale.Increment = New Decimal(New Integer() {1, 0, 0, 65536})
        Me.nudScale.Location = New System.Drawing.Point(358, 0)
        Me.nudScale.Maximum = New Decimal(New Integer() {2, 0, 0, 0})
        Me.nudScale.Name = "nudScale"
        Me.nudScale.Size = New System.Drawing.Size(47, 20)
        Me.nudScale.TabIndex = 21
        '
        'Label6
        '
        Me.Label6.AutoSize = True
        Me.Label6.Location = New System.Drawing.Point(0, 2)
        Me.Label6.Name = "Label6"
        Me.Label6.Size = New System.Drawing.Size(121, 13)
        Me.Label6.TabIndex = 22
        Me.Label6.Text = "Centre of Enlargement: ("
        '
        'Label7
        '
        Me.Label7.AutoSize = True
        Me.Label7.Location = New System.Drawing.Point(122, 2)
        Me.Label7.Name = "Label7"
        Me.Label7.Size = New System.Drawing.Size(12, 13)
        Me.Label7.TabIndex = 16
        Me.Label7.Text = "x"
        '
        'nudXPosition
        '
        Me.nudXPosition.Location = New System.Drawing.Point(137, 0)
        Me.nudXPosition.Maximum = New Decimal(New Integer() {8, 0, 0, 0})
        Me.nudXPosition.Minimum = New Decimal(New Integer() {8, 0, 0, -2147483648})
        Me.nudXPosition.Name = "nudXPosition"
        Me.nudXPosition.Size = New System.Drawing.Size(47, 20)
        Me.nudXPosition.TabIndex = 17
        '
        'Label8
        '
        Me.Label8.AutoSize = True
        Me.Label8.Location = New System.Drawing.Point(197, 2)
        Me.Label8.Name = "Label8"
        Me.Label8.Size = New System.Drawing.Size(12, 13)
        Me.Label8.TabIndex = 18
        Me.Label8.Text = "y"
        '
        'Label9
        '
        Me.Label9.AutoSize = True
        Me.Label9.Location = New System.Drawing.Point(260, 2)
        Me.Label9.Name = "Label9"
        Me.Label9.Size = New System.Drawing.Size(10, 13)
        Me.Label9.TabIndex = 23
        Me.Label9.Text = ")"
        '
        'Label10
        '
        Me.Label10.AutoSize = True
        Me.Label10.Location = New System.Drawing.Point(268, 2)
        Me.Label10.Name = "Label10"
        Me.Label10.Size = New System.Drawing.Size(70, 13)
        Me.Label10.TabIndex = 20
        Me.Label10.Text = "Scale Factor:"
        '
        'lblPolarity
        '
        Me.lblPolarity.BackColor = System.Drawing.SystemColors.Window
        Me.lblPolarity.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lblPolarity.Location = New System.Drawing.Point(343, 0)
        Me.lblPolarity.Name = "lblPolarity"
        Me.lblPolarity.Padding = New System.Windows.Forms.Padding(0, 0, 0, 3)
        Me.lblPolarity.Size = New System.Drawing.Size(15, 20)
        Me.lblPolarity.TabIndex = 17
        Me.lblPolarity.Text = "+"
        Me.lblPolarity.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'nudYPosition
        '
        Me.nudYPosition.AutoSize = True
        Me.nudYPosition.Location = New System.Drawing.Point(215, 0)
        Me.nudYPosition.Maximum = New Decimal(New Integer() {10, 0, 0, 0})
        Me.nudYPosition.Minimum = New Decimal(New Integer() {6, 0, 0, -2147483648})
        Me.nudYPosition.Name = "nudYPosition"
        Me.nudYPosition.Size = New System.Drawing.Size(47, 20)
        Me.nudYPosition.TabIndex = 19
        Me.ContextMenuStrip1.ResumeLayout(False)
        Me.Panel1.ResumeLayout(False)
        Me.Panel1.PerformLayout()
        CType(Me.nudScale, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.nudXPosition, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.nudYPosition, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)

    End Sub

End Class
