﻿Public Class Reflection
    Inherits Panel

    Friend WithEvents cboLine As System.Windows.Forms.ComboBox
    Friend WithEvents Label4 As System.Windows.Forms.Label
    Friend WithEvents ContextMenuStrip1 As System.Windows.Forms.ContextMenuStrip
    Private components As System.ComponentModel.IContainer
    Friend WithEvents ClearToolStripMenuItem As System.Windows.Forms.ToolStripMenuItem
    Friend WithEvents Label3 As System.Windows.Forms.Label
    Friend WithEvents nudIntersection As System.Windows.Forms.NumericUpDown
    Friend WithEvents Panel1 As System.Windows.Forms.Panel

    Public Sub New()

        InitializeComponent()

        Me.DoubleBuffered = True

        cboLine.DataSource = New String() {"Vertical", "Horizontal", "Diagonal - SW to NE", "Diagonal - NW to SE"}

        nudIntersection.Minimum = -4
        nudIntersection.Maximum = 4

        Me.ContextMenuStrip = ContextMenuStrip1
        ContextMenuStrip1.Enabled = False

        Me.Controls.Add(Panel1)
        Panel1.SetBounds(25, 461, Panel1.Width, Panel1.Height, BoundsSpecified.Location)

        Me.Dock = DockStyle.Fill
    End Sub

    Protected Overrides Sub OnPaint(ByVal e As System.Windows.Forms.PaintEventArgs)

        methods.drawGrid(e.Graphics, Me.Font)

        Dim l As Integer = 25 + ((CInt(nudIntersection.Value) + 8) * 25)
        Dim t As Integer = 25 + (Math.Abs(CInt(nudIntersection.Value) - 10) * 25)
        Dim v As Integer = CInt(nudIntersection.Value)

        methods.drawMirrorLine(e.Graphics, l, t, v, cboLine.SelectedIndex)
        methods.drawShape(e.Graphics, sharedVariables.allVertices(1))
        methods.drawMirrorShape(e.Graphics, sharedVariables.allVertices(1), v, cboLine.SelectedIndex)
        methods.drawBorders(e.Graphics, Me.BackColor)
        methods.drawHighlight(e.Graphics, sharedVariables.allHighlights(1))

        MyBase.OnPaint(e)
    End Sub

    Private Sub ClearToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ClearToolStripMenuItem.Click
        sharedVariables.allVertices(1).Clear()
        Me.Refresh()
    End Sub

    Private Sub cboLine_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboLine.SelectedIndexChanged
        nudIntersection.Value = 0
        nudIntersection.Minimum = -3
        Me.Refresh()
    End Sub

    Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Me.Panel1 = New System.Windows.Forms.Panel
        Me.nudIntersection = New System.Windows.Forms.NumericUpDown
        Me.Label3 = New System.Windows.Forms.Label
        Me.Label4 = New System.Windows.Forms.Label
        Me.cboLine = New System.Windows.Forms.ComboBox
        Me.ContextMenuStrip1 = New System.Windows.Forms.ContextMenuStrip(Me.components)
        Me.ClearToolStripMenuItem = New System.Windows.Forms.ToolStripMenuItem
        Me.Panel1.SuspendLayout()
        CType(Me.nudIntersection, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.ContextMenuStrip1.SuspendLayout()
        Me.SuspendLayout()
        '
        'Panel1
        '
        Me.Panel1.Controls.Add(Me.nudIntersection)
        Me.Panel1.Controls.Add(Me.Label3)
        Me.Panel1.Controls.Add(Me.Label4)
        Me.Panel1.Controls.Add(Me.cboLine)
        Me.Panel1.Location = New System.Drawing.Point(34, 248)
        Me.Panel1.Name = "Panel1"
        Me.Panel1.Size = New System.Drawing.Size(400, 23)
        Me.Panel1.TabIndex = 5
        '
        'nudIntersection
        '
        Me.nudIntersection.Location = New System.Drawing.Point(358, 2)
        Me.nudIntersection.Maximum = New Decimal(New Integer() {7, 0, 0, 0})
        Me.nudIntersection.Minimum = New Decimal(New Integer() {3, 0, 0, -2147483648})
        Me.nudIntersection.Name = "nudIntersection"
        Me.nudIntersection.Size = New System.Drawing.Size(42, 20)
        Me.nudIntersection.TabIndex = 8
        '
        'Label3
        '
        Me.Label3.AutoSize = True
        Me.Label3.Location = New System.Drawing.Point(298, 6)
        Me.Label3.Name = "Label3"
        Me.Label3.Size = New System.Drawing.Size(56, 13)
        Me.Label3.TabIndex = 7
        Me.Label3.Text = "Intersects:"
        '
        'Label4
        '
        Me.Label4.AutoSize = True
        Me.Label4.Location = New System.Drawing.Point(3, 6)
        Me.Label4.Name = "Label4"
        Me.Label4.Size = New System.Drawing.Size(90, 13)
        Me.Label4.TabIndex = 5
        Me.Label4.Text = "Line of Symmetry:"
        '
        'cboLine
        '
        Me.cboLine.FormattingEnabled = True
        Me.cboLine.Location = New System.Drawing.Point(98, 1)
        Me.cboLine.Name = "cboLine"
        Me.cboLine.Size = New System.Drawing.Size(187, 21)
        Me.cboLine.TabIndex = 6
        '
        'ContextMenuStrip1
        '
        Me.ContextMenuStrip1.Items.AddRange(New System.Windows.Forms.ToolStripItem() {Me.ClearToolStripMenuItem})
        Me.ContextMenuStrip1.Name = "ContextMenuStrip1"
        Me.ContextMenuStrip1.Size = New System.Drawing.Size(153, 48)
        '
        'ClearToolStripMenuItem
        '
        Me.ClearToolStripMenuItem.Name = "ClearToolStripMenuItem"
        Me.ClearToolStripMenuItem.Size = New System.Drawing.Size(152, 22)
        Me.ClearToolStripMenuItem.Text = "Clear"
        Me.Panel1.ResumeLayout(False)
        Me.Panel1.PerformLayout()
        CType(Me.nudIntersection, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ContextMenuStrip1.ResumeLayout(False)
        Me.ResumeLayout(False)

    End Sub
End Class
