﻿Public Class Rotation
    Inherits Panel

    Friend WithEvents ClearToolStripMenuItem As System.Windows.Forms.ToolStripMenuItem
    Private components As System.ComponentModel.IContainer
    Friend WithEvents Panel1 As System.Windows.Forms.Panel
    Friend WithEvents lblPolarity As System.Windows.Forms.Label
    Friend WithEvents Label8 As System.Windows.Forms.Label
    Friend WithEvents Label9 As System.Windows.Forms.Label
    Friend WithEvents nudAngle As System.Windows.Forms.NumericUpDown
    Friend WithEvents Label10 As System.Windows.Forms.Label
    Friend WithEvents nudYCentre As System.Windows.Forms.NumericUpDown
    Friend WithEvents Label11 As System.Windows.Forms.Label
    Friend WithEvents nudXCentre As System.Windows.Forms.NumericUpDown
    Friend WithEvents Label12 As System.Windows.Forms.Label
    Friend WithEvents ContextMenuStrip1 As System.Windows.Forms.ContextMenuStrip

    Public Sub New()

        InitializeComponent()

        Me.DoubleBuffered = True

        Me.Controls.Add(Panel1)
        Panel1.SetBounds(25, 458, Panel1.Width, Panel1.Height, BoundsSpecified.Location)

        ContextMenuStrip1.Enabled = False
        Me.ContextMenuStrip = ContextMenuStrip1

        Me.Dock = DockStyle.Fill

    End Sub

    Protected Overrides Sub OnPaint(ByVal e As System.Windows.Forms.PaintEventArgs)

        methods.drawGrid(e.Graphics, Me.Font)

        Dim l As Integer = 25 + ((CInt(nudXCentre.Value) + 8) * 25)
        Dim t As Integer = 25 + (Math.Abs(CInt(nudYCentre.Value) - 10) * 25)
        Dim v As Integer = CInt(nudAngle.Value)

        methods.drawShape(e.Graphics, sharedVariables.allVertices(2))
        methods.drawRotatedShape(e.Graphics, sharedVariables.allVertices(2), v, l, t, lblPolarity.Text)
        methods.drawBorders(e.Graphics, Me.BackColor)
        methods.drawCross(e.Graphics, l, t)
        methods.drawHighlight(e.Graphics, sharedVariables.allHighlights(2))

        MyBase.OnPaint(e)
    End Sub

    Private Sub lblPolarity_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lblPolarity.Click
        If lblPolarity.Text = "-" Then lblPolarity.Text = "+" Else lblPolarity.Text = "-"
        Me.Refresh()
    End Sub

    Private Sub ClearToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ClearToolStripMenuItem.Click
        sharedVariables.allVertices(2).Clear()
        Me.Refresh()
    End Sub

    Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Me.ContextMenuStrip1 = New System.Windows.Forms.ContextMenuStrip(Me.components)
        Me.ClearToolStripMenuItem = New System.Windows.Forms.ToolStripMenuItem
        Me.Panel1 = New System.Windows.Forms.Panel
        Me.lblPolarity = New System.Windows.Forms.Label
        Me.Label8 = New System.Windows.Forms.Label
        Me.Label9 = New System.Windows.Forms.Label
        Me.nudAngle = New System.Windows.Forms.NumericUpDown
        Me.Label10 = New System.Windows.Forms.Label
        Me.nudYCentre = New System.Windows.Forms.NumericUpDown
        Me.Label11 = New System.Windows.Forms.Label
        Me.nudXCentre = New System.Windows.Forms.NumericUpDown
        Me.Label12 = New System.Windows.Forms.Label
        Me.ContextMenuStrip1.SuspendLayout()
        Me.Panel1.SuspendLayout()
        CType(Me.nudAngle, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.nudYCentre, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.nudXCentre, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'ContextMenuStrip1
        '
        Me.ContextMenuStrip1.Items.AddRange(New System.Windows.Forms.ToolStripItem() {Me.ClearToolStripMenuItem})
        Me.ContextMenuStrip1.Name = "ContextMenuStrip1"
        Me.ContextMenuStrip1.Size = New System.Drawing.Size(102, 26)
        '
        'ClearToolStripMenuItem
        '
        Me.ClearToolStripMenuItem.Name = "ClearToolStripMenuItem"
        Me.ClearToolStripMenuItem.Size = New System.Drawing.Size(101, 22)
        Me.ClearToolStripMenuItem.Text = "Clear"
        '
        'Panel1
        '
        Me.Panel1.Controls.Add(Me.lblPolarity)
        Me.Panel1.Controls.Add(Me.Label8)
        Me.Panel1.Controls.Add(Me.Label9)
        Me.Panel1.Controls.Add(Me.nudAngle)
        Me.Panel1.Controls.Add(Me.Label10)
        Me.Panel1.Controls.Add(Me.nudYCentre)
        Me.Panel1.Controls.Add(Me.Label11)
        Me.Panel1.Controls.Add(Me.nudXCentre)
        Me.Panel1.Controls.Add(Me.Label12)
        Me.Panel1.Location = New System.Drawing.Point(44, 314)
        Me.Panel1.Name = "Panel1"
        Me.Panel1.Size = New System.Drawing.Size(400, 20)
        Me.Panel1.TabIndex = 9
        '
        'lblPolarity
        '
        Me.lblPolarity.BackColor = System.Drawing.SystemColors.Window
        Me.lblPolarity.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lblPolarity.Location = New System.Drawing.Point(338, 0)
        Me.lblPolarity.Name = "lblPolarity"
        Me.lblPolarity.Padding = New System.Windows.Forms.Padding(0, 0, 0, 3)
        Me.lblPolarity.Size = New System.Drawing.Size(15, 20)
        Me.lblPolarity.TabIndex = 17
        Me.lblPolarity.Text = "-"
        Me.lblPolarity.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'Label8
        '
        Me.Label8.AutoSize = True
        Me.Label8.Location = New System.Drawing.Point(235, 2)
        Me.Label8.Name = "Label8"
        Me.Label8.Size = New System.Drawing.Size(10, 13)
        Me.Label8.TabIndex = 16
        Me.Label8.Text = ")"
        '
        'Label9
        '
        Me.Label9.AutoSize = True
        Me.Label9.Location = New System.Drawing.Point(0, 2)
        Me.Label9.Name = "Label9"
        Me.Label9.Size = New System.Drawing.Size(102, 13)
        Me.Label9.TabIndex = 15
        Me.Label9.Text = "Centre of Rotation: ("
        '
        'nudAngle
        '
        Me.nudAngle.Increment = New Decimal(New Integer() {90, 0, 0, 0})
        Me.nudAngle.Location = New System.Drawing.Point(353, 0)
        Me.nudAngle.Maximum = New Decimal(New Integer() {270, 0, 0, 0})
        Me.nudAngle.Name = "nudAngle"
        Me.nudAngle.Size = New System.Drawing.Size(47, 20)
        Me.nudAngle.TabIndex = 14
        Me.nudAngle.Value = New Decimal(New Integer() {90, 0, 0, 0})
        '
        'Label10
        '
        Me.Label10.AutoSize = True
        Me.Label10.Location = New System.Drawing.Point(243, 2)
        Me.Label10.Name = "Label10"
        Me.Label10.Size = New System.Drawing.Size(92, 13)
        Me.Label10.TabIndex = 13
        Me.Label10.Text = "Angle of Rotation:"
        '
        'nudYCentre
        '
        Me.nudYCentre.Location = New System.Drawing.Point(190, 0)
        Me.nudYCentre.Maximum = New Decimal(New Integer() {10, 0, 0, 0})
        Me.nudYCentre.Minimum = New Decimal(New Integer() {6, 0, 0, -2147483648})
        Me.nudYCentre.Name = "nudYCentre"
        Me.nudYCentre.Size = New System.Drawing.Size(47, 20)
        Me.nudYCentre.TabIndex = 12
        '
        'Label11
        '
        Me.Label11.AutoSize = True
        Me.Label11.Location = New System.Drawing.Point(175, 2)
        Me.Label11.Name = "Label11"
        Me.Label11.Size = New System.Drawing.Size(12, 13)
        Me.Label11.TabIndex = 11
        Me.Label11.Text = "y"
        '
        'nudXCentre
        '
        Me.nudXCentre.Location = New System.Drawing.Point(115, 0)
        Me.nudXCentre.Maximum = New Decimal(New Integer() {8, 0, 0, 0})
        Me.nudXCentre.Minimum = New Decimal(New Integer() {8, 0, 0, -2147483648})
        Me.nudXCentre.Name = "nudXCentre"
        Me.nudXCentre.Size = New System.Drawing.Size(47, 20)
        Me.nudXCentre.TabIndex = 10
        '
        'Label12
        '
        Me.Label12.AutoSize = True
        Me.Label12.Location = New System.Drawing.Point(100, 2)
        Me.Label12.Name = "Label12"
        Me.Label12.Size = New System.Drawing.Size(12, 13)
        Me.Label12.TabIndex = 9
        Me.Label12.Text = "x"
        Me.ContextMenuStrip1.ResumeLayout(False)
        Me.Panel1.ResumeLayout(False)
        Me.Panel1.PerformLayout()
        CType(Me.nudAngle, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.nudYCentre, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.nudXCentre, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)

    End Sub
End Class
