Public Class angles

    ''' <summary>
    ''' returns degrees in this coordinate system:
    ''' N,E,S,W = 270,0,90,180 degrees
    ''' </summary>
    ''' <param name="p1">point1</param>
    ''' <param name="p2">point2</param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Shared Function FindAngle(ByVal p1 As Point, ByVal p2 As Point) As Integer

        Dim angle As Integer = CInt(Math.Round(Math.Atan((p1.Y - p2.Y) / If((p1.X - p2.X) = 0, 1, (p1.X - p2.X))) * (180 / Math.PI), 0))

        If angle = 0 Then
            If p1.X > p2.X Then
                Return 180
            ElseIf p2.X > p1.X Then
                Return 0
            End If
        End If

        If p2.Y <= p1.Y Then
            If angle > 0 Then
                angle += 180
            Else
                angle += 360
            End If
        Else
            If angle < 0 Then
                angle += 180
            End If
        End If

        Return angle

    End Function
End Class
